Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/GameTools_Localized_EnvMap.hlsl
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/GameTools_Localized_EnvMap.hlsl	(revision 1700)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/GameTools_Localized_EnvMap.hlsl	(revision 1712)
@@ -31,22 +31,101 @@
 {
 	float dist = texCUBE(dcm, float3(coord.xy, - coord.z)).r;
-	if(dist == 0) dist = 100000; ///sky
+	//if(dist == 0) dist = 1000; ///sky
 	return dist;
 }
 
-/*
-float3 Hit( float3 x, float3 R, samplerCUBE mp )
-{
-  
-	float rl = readDistanceCubeMap(mp, R); // |r|
-	
-	float dp = rl - dot(x, R);		// parallax
-	
-	float3 p = x + R * dp;
+
+
+#define LIN_ITERATIONCOUNT_L0 20
+#define LIN_ITERATIONCOUNT_L1 5
+#define LIN_ITERATIONCOUNT_L2 3
+#define LIN_ITERATIONCOUNT_L3 1
+#define SECANT_ITERATIONCOUNT 2
+
+float3 Hit(float3 x, float3 R, samplerCUBE mp, float cameraDistance = 0)
+{
+	R = normalize(R);
+	
+	float3 Ra = abs(R);
+	float3 xa = abs(x);
+	float a = max(max(xa.x,xa.y),xa.z) / 
+			  max(max(Ra.x,Ra.y),Ra.z);
+	
+	bool overshoot = false, undershoot = false;
+	float dp, dl = 0, ppp, llp;
+	float lR = readDistanceCubeMap(mp, R);
+	float3 p = R;
+	
+	float LIN_ITERATIONCOUNT = LIN_ITERATIONCOUNT_L0;
+	/*
+	if(cameraDistance < 100)
+		LIN_ITERATIONCOUNT  = (float) LIN_ITERATIONCOUNT_L0;
+	else if(cameraDistance < 200)
+		LIN_ITERATIONCOUNT  = (float) LIN_ITERATIONCOUNT_L1;
+	else if(cameraDistance < 300)
+		LIN_ITERATIONCOUNT  = (float) LIN_ITERATIONCOUNT_L2;
+	else
+		LIN_ITERATIONCOUNT  = (float) LIN_ITERATIONCOUNT_L3;
+	*/
+	
+	float dt = 1.0 / LIN_ITERATIONCOUNT;
+	
+	//linear iteration	
+	float t = 0;
+	while(t < 1.0)
+	{
+		if(!overshoot)
+		{
+			dp = a * t / (1 - t);
+			p = x + R * dp;
+			float dist = readDistanceCubeMap(mp, p);
+			if(dist > 0)
+			{
+				ppp = length(p) / dist;
+				if(ppp < 1)
+				{
+					dl = dp;
+					llp = ppp;		
+					undershoot = true;		
+				}
+				else
+				{
+					if (undershoot) 
+					   overshoot = true;
+				}
+			}
+			else 
+				undershoot = false;
+		}
+		t += dt;		
+	}
+	
+	if(overshoot)
+	{
+		float dnew;
+		for(int i = 0; i < SECANT_ITERATIONCOUNT; i++ )
+		{
+			dnew = dl + (dp - dl) * (1 - llp) / (ppp - llp);	
+			    
+			p = x + R * dnew;
+			half pppnew = length(p) / readDistanceCubeMap(mp, p);
+			if(pppnew < 1)
+			{
+				llp = pppnew;
+				dl = dnew;
+			}
+			else
+			{
+				ppp = pppnew;
+				dp = dnew;
+			}
+		}	
+	}
+	else
+		p = float3(0,0,0);
+	 
 	return p;
-}*/
-
-#define LIN_ITERATIONCOUNT 5
-#define SECANT_ITERATIONCOUNT 0
+}
+				
 /*
 float3 Hit(float3 x, float3 R, samplerCUBE mp)
@@ -81,108 +160,9 @@
 		}	
 	}
-	
-	float3 dirUn = normalize(under);
-	float3 dirOv = normalize(over);
-	float tun = d / dot(N, dirUn);
-	float pun = tun / length(under);
-	float dun = length(tun * dirUn - x);
-	float tov = d / dot(N, dirOv);
-	float pov = tov / length(over);
-	float dov = length(tov * dirOv - x);
-	float tl = (d - dot(N, over)) / dot(N, under - over);
-	float3 l = over + tl * (under - over);
-	float dl = length(l - x);
-		
-	//secant iteration
-	for( int i = 0; i < SECANT_ITERATIONCOUNT; i++ )
-	{
-		float llp = length( l ) / readDistanceCubeMap( mp, l);		// |l|/|l|
-		if ( llp < 0.999f )									// undershooting
-		{
-			dun = dl; pun = llp;							// last undershooting
-			dl += ( dl - dov ) * ( 1 - llp ) / ( llp - pov );	// eq. 3
-		} else if ( llp > 1.001f )							// overshooting
-		{
-			dov = dl; pov = llp;							// last overshooting
-			dl += ( dl - dun ) * ( 1 - llp ) / ( llp - pun );// eq. 3
-		}
-		l = x + R * dl;										// ray equation
-	}
-	
-	return l;		
-	return over;	
-	return (under + over)/2.0;
+	return over;
 }
 */
-float3 Hit(float3 x, float3 R, samplerCUBE mp)
-{
-	R = normalize(R);
-	float3 xNorm = normalize(x);
-	float3 dt = (R - xNorm) / (float) LIN_ITERATIONCOUNT;
-	float dx = length(cross(R,x));
-	
-	float3 pN = normalize(cross(R, xNorm));
-	float3 N = normalize(cross(pN,R));
-	float d = dot(x, N);	
-	
-	float3 under = xNorm * readDistanceCubeMap(mp, x);
-	float3 over = R * readDistanceCubeMap(mp, R);
-	
-	//linear iteration	
-	for(int i = 1; i < LIN_ITERATIONCOUNT; i++)
-	{
-		float3 ldir = normalize(xNorm + dt * i);
-		float lL = readDistanceCubeMap( mp, dir);
-		float3 l_ = dir * dist;
-		float alpha = (dot(x, l_) - dot(R, l_) * dot(x, R)) / (lL * lL - dot(R, l_) * dot(R, l_));
-		float d = dot(l_, R) * alpha - dot(x, R);
-		
-		if( dot(N, point) > d)//undershooting
-		{
-			under = point;			
-		}
-		else				//overshooting
-		{
-			over = point;			
-			i = LIN_ITERATIONCOUNT;
-		}	
-	}
-	
-	float3 dirUn = normalize(under);
-	float3 dirOv = normalize(over);
-	float tun = d / dot(N, dirUn);
-	float pun = tun / length(under);
-	float dun = length(tun * dirUn - x);
-	float tov = d / dot(N, dirOv);
-	float pov = tov / length(over);
-	float dov = length(tov * dirOv - x);
-	float tl = (d - dot(N, over)) / dot(N, under - over);
-	float3 l = over + tl * (under - over);
-	float dl = length(l - x);
-		
-	//secant iteration
-	for( int i = 0; i < SECANT_ITERATIONCOUNT; i++ )
-	{
-		float llp = length( l ) / readDistanceCubeMap( mp, l);		// |l|/|l|
-		if ( llp < 0.999f )									// undershooting
-		{
-			dun = dl; pun = llp;							// last undershooting
-			dl += ( dl - dov ) * ( 1 - llp ) / ( llp - pov );	// eq. 3
-		} else if ( llp > 1.001f )							// overshooting
-		{
-			dov = dl; pov = llp;							// last overshooting
-			dl += ( dl - dun ) * ( 1 - llp ) / ( llp - pun );// eq. 3
-		}
-		l = x + R * dl;										// ray equation
-	}
-	
-	return l;		
-	return over;	
-	return (under + over)/2.0;
-}
-
 
 /*
-// This function is called several times.
 float3 Hit( float3 x, float3 R, samplerCUBE mp )
 {
@@ -195,5 +175,5 @@
 
 	// iteration
-	for( int i = 0; i < 2; i++ )	// 2 !!!!!!!!!!!!!!!!!!!!!!!
+	for( int i = 0; i < SECANT_ITERATIONCOUNT; i++ )
 	{
 		float llp = length( l ) / readDistanceCubeMap( mp, l);		// |l|/|l|
@@ -293,12 +273,16 @@
 	float3 newTexCoord;	
 	float3 mPos = wPos - lastCenter;
-	float3 V = normalize(wPos - cameraPos);
+	float3 V  = (wPos - cameraPos);
+	float cameraDistace = length(V);
+	V = normalize(V);
 	float3 R = normalize(reflect( V, mNormal));
 		
 	newTexCoord = R;	
 	
-	newTexCoord = Hit(mPos, R, DistanceMap);
-	
-	Color = readCubeMap(CubeMap, newTexCoord ) /*+ lastCenter.x*0.000001*/;	
+	newTexCoord = Hit(mPos, R, DistanceMap, cameraDistace);
+	if(dot(newTexCoord,newTexCoord) == 0) 
+		Color = float4(0.5,0.5,0.5,1);
+	else
+		Color = readCubeMap(CubeMap, newTexCoord );	
 	
 	float ctheta_in = dot(mNormal,R);
Index: GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsParticleDemo/scripts/GameToolsParticleDemo.vcproj
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsParticleDemo/scripts/GameToolsParticleDemo.vcproj	(revision 1683)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsParticleDemo/scripts/GameToolsParticleDemo.vcproj	(revision 1712)
@@ -42,5 +42,5 @@
 				Optimization="0"
 				AdditionalIncludeDirectories="..\include;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderingRuns;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderingRuns"
-				PreprocessorDefinitions="WIN32;_DEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE;GTP_VISIBILITY_MODIFIED_OGRE"
+				PreprocessorDefinitions="WIN32;_DEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE"
 				MinimalRebuild="true"
 				BasicRuntimeChecks="3"
@@ -133,5 +133,5 @@
 				EnableFiberSafeOptimizations="false"
 				AdditionalIncludeDirectories="..\include;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderingRuns;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderingRuns"
-				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE;GTP_VISIBILITY_MODIFIED_OGRE"
+				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE"
 				StringPooling="true"
 				MinimalRebuild="true"
Index: GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsToneMapDemo/scripts/GameToolsToneMapDemo.vcproj
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsToneMapDemo/scripts/GameToolsToneMapDemo.vcproj	(revision 1683)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsToneMapDemo/scripts/GameToolsToneMapDemo.vcproj	(revision 1712)
@@ -43,5 +43,5 @@
 				Optimization="0"
 				AdditionalIncludeDirectories="..\include;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderingRuns;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderingRuns"
-				PreprocessorDefinitions="WIN32;_DEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE;GTP_VISIBILITY_MODIFIED_OGRE"
+				PreprocessorDefinitions="WIN32;_DEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE"
 				MinimalRebuild="true"
 				BasicRuntimeChecks="3"
@@ -134,5 +134,5 @@
 				EnableFiberSafeOptimizations="false"
 				AdditionalIncludeDirectories="..\include;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderingRuns;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderingRuns"
-				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE;GTP_VISIBILITY_MODIFIED_OGRE"
+				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE"
 				StringPooling="true"
 				MinimalRebuild="true"
Index: GTP/trunk/App/Demos/Illum/Ogre/src/HierarchicalSystem/scripts/HierarchicalSystem.vcproj
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/HierarchicalSystem/scripts/HierarchicalSystem.vcproj	(revision 1683)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/HierarchicalSystem/scripts/HierarchicalSystem.vcproj	(revision 1712)
@@ -43,5 +43,5 @@
 				Optimization="0"
 				AdditionalIncludeDirectories="..\include;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderingRuns;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderingRuns"
-				PreprocessorDefinitions="WIN32;_DEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE;GTP_VISIBILITY_MODIFIED_OGRE"
+				PreprocessorDefinitions="WIN32;_DEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE"
 				MinimalRebuild="true"
 				BasicRuntimeChecks="3"
@@ -134,5 +134,5 @@
 				EnableFiberSafeOptimizations="false"
 				AdditionalIncludeDirectories="..\include;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderingRuns;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderingRuns"
-				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE;GTP_VISIBILITY_MODIFIED_OGRE"
+				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE"
 				StringPooling="true"
 				MinimalRebuild="true"
Index: GTP/trunk/App/Demos/Illum/Ogre/src/PRMDemo/scripts/PRMDemo.vcproj
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/PRMDemo/scripts/PRMDemo.vcproj	(revision 1683)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/PRMDemo/scripts/PRMDemo.vcproj	(revision 1712)
@@ -43,5 +43,5 @@
 				Optimization="0"
 				AdditionalIncludeDirectories="..\include;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderingRuns;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderingRuns;..\..\Common\include"
-				PreprocessorDefinitions="WIN32;_DEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE;GTP_VISIBILITY_MODIFIED_OGRE"
+				PreprocessorDefinitions="WIN32;_DEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE"
 				MinimalRebuild="true"
 				BasicRuntimeChecks="3"
@@ -134,5 +134,5 @@
 				EnableFiberSafeOptimizations="false"
 				AdditionalIncludeDirectories="..\include;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderingRuns;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderingRuns;..\..\Common\include"
-				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE;GTP_VISIBILITY_MODIFIED_OGRE"
+				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE"
 				StringPooling="true"
 				MinimalRebuild="true"
Index: GTP/trunk/App/Demos/Illum/Ogre/src/DiffuseTest/scripts/DiffuseTest.vcproj
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/DiffuseTest/scripts/DiffuseTest.vcproj	(revision 1683)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/DiffuseTest/scripts/DiffuseTest.vcproj	(revision 1712)
@@ -43,5 +43,5 @@
 				Optimization="0"
 				AdditionalIncludeDirectories="..\include;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderingRuns;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderingRuns"
-				PreprocessorDefinitions="WIN32;_DEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE;GTP_VISIBILITY_MODIFIED_OGRE"
+				PreprocessorDefinitions="WIN32;_DEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE"
 				MinimalRebuild="true"
 				BasicRuntimeChecks="3"
@@ -134,5 +134,5 @@
 				EnableFiberSafeOptimizations="false"
 				AdditionalIncludeDirectories="..\include;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderingRuns;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderingRuns"
-				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE;GTP_VISIBILITY_MODIFIED_OGRE"
+				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE"
 				StringPooling="true"
 				MinimalRebuild="true"
@@ -260,4 +260,8 @@
 			</File>
 			<File
+				RelativePath=".\Hit.txt"
+				>
+			</File>
+			<File
 				RelativePath="..\..\..\Media\materials\scripts\uvegfolyoso2.material"
 				>
Index: GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsRaytraceDemo/include/GameToolsRaytraceDemo.h
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsRaytraceDemo/include/GameToolsRaytraceDemo.h	(revision 1691)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsRaytraceDemo/include/GameToolsRaytraceDemo.h	(revision 1712)
@@ -40,4 +40,5 @@
 	SceneNode* copperSphereNode;
 	SceneNode* aluSphereNode;
+	SceneNode* centerSphereNode;
 	SceneNode* lightNode;
 	Light* light;
@@ -50,4 +51,5 @@
 																SceneNode* copperSphereNode,
 																SceneNode* aluSphereNode,
+																SceneNode* centerSphereNode,
 																Light* light)
         :ExampleFrameListener(window, maincam) 
@@ -59,4 +61,5 @@
 		this->copperSphereNode = copperSphereNode;
 		this->aluSphereNode = aluSphereNode;
+		this->centerSphereNode = centerSphereNode;
 		this->lightNode = lightNode;
 		this->light = light;
@@ -93,4 +96,22 @@
 		}
 	*/
+		if (mInputDevice->isKeyDown(KC_SPACE))
+        {
+			mTimeUntilNextToggle = 2;
+			static bool first = true;
+			first = !first;
+			goldSphereNode->setVisible(first,true);
+			goldSphereNode->setVisible(!first,false);
+			aluSphereNode->setVisible(first,true);
+			aluSphereNode->setVisible(!first,false);
+			silverSphereNode->setVisible(first,true);
+			silverSphereNode->setVisible(!first,false);
+			copperSphereNode->setVisible(first,true);
+			copperSphereNode->setVisible(!first,false);
+			centerSphereNode->setVisible(first,true);
+			centerSphereNode->setVisible(!first,false);
+			
+		
+		}
 
 		return ExampleFrameListener::processUnbufferedKeyInput(evt);
@@ -157,4 +178,5 @@
 	SceneNode* copperSphereNode;
 	SceneNode* aluSphereNode;
+	SceneNode* centerSphereNode;
 	Light* mainLight;
 
@@ -200,9 +222,18 @@
 		//init objects
 		Entity* kupola = mSceneMgr->createEntity("kupola", "kupola.mesh");
-		Entity* athene = mSceneMgr->createEntity("athene", "head.mesh");
-		Entity* goldSphere = mSceneMgr->createEntity("goldSphere", "head.mesh");
-		Entity* silverSphere = mSceneMgr->createEntity("silverSphere", "head.mesh");
-		Entity* copperSphere = mSceneMgr->createEntity("copperSphere", "head.mesh");
-		Entity* aluSphere = mSceneMgr->createEntity("aluSphere", "head.mesh");
+	
+		Entity* centerHead = mSceneMgr->createEntity("centerHead", "head.mesh");
+		Entity* goldHead = mSceneMgr->createEntity("goldHead", "head.mesh");
+		Entity* silverHead = mSceneMgr->createEntity("silverHeade", "head.mesh");
+		Entity* copperHead = mSceneMgr->createEntity("copperHead", "head.mesh");
+		Entity* aluHead = mSceneMgr->createEntity("aluHead", "head.mesh");
+
+		Entity* centerSphere = mSceneMgr->createEntity("centerSphere", "sphere.mesh");
+		Entity* goldSphere = mSceneMgr->createEntity("goldSphere", "sphere.mesh");
+		Entity* silverSphere = mSceneMgr->createEntity("silverSphere", "sphere.mesh");
+		Entity* copperSphere = mSceneMgr->createEntity("copperSphere", "sphere.mesh");
+		Entity* aluSphere = mSceneMgr->createEntity("aluSphere", "sphere.mesh");
+
+
 
 		kupola->setCastShadows(false);
@@ -229,25 +260,39 @@
 		//kupolaNode->scale(2,2,2);		
 		//kupolaNode->setPosition(0,100,0);
-		SceneNode* atheneNode = rootNode->createChildSceneNode("athene");
-		atheneNode->attachObject(athene);
-		//atheneNode->setScale(3.5,5.5,5.5);
-		atheneNode->setScale(4,4,4);
-		//atheneNode->setScale(0.5,0.5,0.5);
-		AxisAlignedBox bbox = athene->getBoundingBox();
-		atheneNode->setPosition(0, 100,0);
+
+		centerSphereNode = rootNode->createChildSceneNode("centerSphere");
+		SceneNode* centerHeadNode = centerSphereNode->createChildSceneNode("centerHead");
+		centerSphereNode->setPosition(0, 100,0);
+		centerHeadNode->attachObject(centerHead);
+		centerSphereNode->attachObject(centerSphere);
+		centerSphereNode->setScale(0.4,0.4,0.4);
+		centerHeadNode->setScale(8,8,8);		
+		centerHeadNode->setVisible(false, false);
 		
 
 		goldSphereNode = rootNode->createChildSceneNode( "goldSphere" );
-		//goldSphereNode->scale(0.3,0.3,0.3);
-		goldSphereNode->scale(2,2,2);
+		SceneNode* goldHeadNode = goldSphereNode->createChildSceneNode( "goldHead" );
+		goldSphereNode->scale(0.3,0.3,0.3);
+		goldHeadNode->setScale(8,8,8);
+		goldHeadNode->setVisible(false, false);
+
 		silverSphereNode = rootNode->createChildSceneNode( "silverSphere" );
-		//silverSphereNode->scale(0.3,0.3,0.3);
-		silverSphereNode->scale(2,2,2);
+		SceneNode* silverHeadNode = silverSphereNode->createChildSceneNode( "silverHead" );
+		silverSphereNode->scale(0.3,0.3,0.3);
+		silverHeadNode->setScale(8,8,8);
+		silverHeadNode->setVisible(false, false);
+
+		aluSphereNode = rootNode->createChildSceneNode( "aluSphere" );
+		SceneNode* aluHeadNode = aluSphereNode->createChildSceneNode( "aluHead" );
+		aluSphereNode->scale(0.3,0.3,0.3);
+		aluHeadNode->setScale(8,8,8);
+		aluHeadNode->setVisible(false, false);
+
 		copperSphereNode = rootNode->createChildSceneNode( "copperSphere" );
-		//copperSphereNode->scale(0.3,0.3,0.3);
-		copperSphereNode->scale(2,2,2);
-		aluSphereNode = rootNode->createChildSceneNode( "aluSphere" );
-		//aluSphereNode->scale(0.3,0.3,0.3);
-		aluSphereNode->scale(2,2,2);
+		SceneNode* copperHeadNode = copperSphereNode->createChildSceneNode( "copperHead" );
+		copperSphereNode->scale(0.3,0.3,0.3);
+		copperHeadNode->setScale(8,8,8);
+		copperHeadNode->setVisible(false, false);
+		
 
 		goldSphereNode->attachObject(goldSphere);
@@ -255,4 +300,10 @@
 		aluSphereNode->attachObject(aluSphere);
 		copperSphereNode->attachObject(copperSphere);
+		
+		goldHeadNode->attachObject(goldHead);
+		silverHeadNode->attachObject(silverHead);
+		aluHeadNode->attachObject(aluHead);
+		copperHeadNode->attachObject(copperHead);
+	
 
 		goldSphereNode->_updateBounds();
@@ -261,6 +312,12 @@
 		copperSphereNode->_updateBounds();
 
+		goldHeadNode->_updateBounds();
+		silverHeadNode->_updateBounds();
+		aluHeadNode->_updateBounds();
+		copperHeadNode->_updateBounds();
+
 		kupolaNode->_updateBounds();
-		atheneNode->_updateBounds();
+		centerSphereNode->_updateBounds();
+		centerHeadNode->_updateBounds();
 
 		//Init lights
@@ -279,18 +336,18 @@
 		bbs->setMaterialName("Flare");
 		mainLightNode->attachObject(bbs);
+		
+		silverSphere->setMaterialName("EnvMetals/Silver");
+		copperSphere->setMaterialName("EnvMetals/Copper");
+		goldSphere->setMaterialName("EnvMetals/Gold");
 		aluSphere->setMaterialName("EnvMetals/Alu");
-		copperSphere->setMaterialName("EnvMetals/Copper");
-		
-		{
-			Material* oldmat = (Material*) MaterialManager::getSingleton().getByName("EnvMetals/Gold").getPointer();
-			Material* newmat = oldmat->clone("gold1").getPointer();
-			Material* newmat2 = oldmat->clone("gold2").getPointer();
-
-			goldSphere->setMaterialName(newmat->getName());
-			silverSphere->setMaterialName(newmat2->getName());
-		}
-
-		athene->setMaterialName("GameTools/CausticGlass");
-		//athene->setMaterialName("GameTools/CubeMap/Diffuse");
+
+		aluHead->setMaterialName("EnvMetals/Alu");
+		copperHead->setMaterialName("EnvMetals/Copper");
+		goldHead->setMaterialName("EnvMetals/Gold");
+		silverHead->setMaterialName("EnvMetals/Silver");
+			
+
+		centerSphere->setMaterialName("GameTools/CausticGlass");
+		centerHead->setMaterialName("GameTools/CausticGlass");
 		
 		OgreIlluminationManager::getSingleton().initTechniques();
@@ -309,4 +366,5 @@
 											copperSphereNode,
 											aluSphereNode,
+											centerSphereNode,
 											mainLight);
 		mFrameListener->setPriority(1);
Index: GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsRaytraceDemo/scripts/GameToolsRaytraceDemo.vcproj
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsRaytraceDemo/scripts/GameToolsRaytraceDemo.vcproj	(revision 1691)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsRaytraceDemo/scripts/GameToolsRaytraceDemo.vcproj	(revision 1712)
@@ -43,5 +43,5 @@
 				Optimization="0"
 				AdditionalIncludeDirectories="..\include;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderingRuns;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderingRuns"
-				PreprocessorDefinitions="WIN32;_DEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE;GTP_VISIBILITY_MODIFIED_OGRE"
+				PreprocessorDefinitions="WIN32;_DEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE"
 				MinimalRebuild="true"
 				BasicRuntimeChecks="3"
@@ -134,5 +134,5 @@
 				EnableFiberSafeOptimizations="false"
 				AdditionalIncludeDirectories="..\include;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderingRuns;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderingRuns"
-				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE;GTP_VISIBILITY_MODIFIED_OGRE"
+				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE"
 				StringPooling="true"
 				MinimalRebuild="true"
Index: GTP/trunk/App/Demos/Illum/Ogre/src/CausticTest/scripts/CausticTest.vcproj
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/CausticTest/scripts/CausticTest.vcproj	(revision 1691)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/CausticTest/scripts/CausticTest.vcproj	(revision 1712)
@@ -43,5 +43,5 @@
 				Optimization="0"
 				AdditionalIncludeDirectories="..\include;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderingRuns;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderingRuns"
-				PreprocessorDefinitions="WIN32;_DEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE;GTP_VISIBILITY_MODIFIED_OGRE"
+				PreprocessorDefinitions="WIN32;_DEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE"
 				MinimalRebuild="true"
 				BasicRuntimeChecks="3"
@@ -134,5 +134,5 @@
 				EnableFiberSafeOptimizations="false"
 				AdditionalIncludeDirectories="..\include;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderingRuns;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderingRuns"
-				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE;GTP_VISIBILITY_MODIFIED_OGRE"
+				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE"
 				StringPooling="true"
 				MinimalRebuild="true"
Index: GTP/trunk/App/Demos/Illum/Ogre/bin/Debug/ogre.cfg
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/bin/Debug/ogre.cfg	(revision 1525)
+++ GTP/trunk/App/Demos/Illum/Ogre/bin/Debug/ogre.cfg	(revision 1712)
@@ -6,5 +6,5 @@
 Floating-point mode=Fastest
 Full Screen=No
-Rendering Device=NVIDIA GeForce 6800 GT
+Rendering Device=NVIDIA GeForce 7950 GX2
 VSync=No
 Video Mode=800 x 600 @ 32-bit colour
